﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TotallyRadEngine10;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework;
using PolygonCollisionLibrary;

namespace ProjectMaternity
{
    public class Chair : Interactable
    {
        public Polygon InteractionPoly;
        //public List<Item> Items;

        // Reference to the patient following the player
        //private Patient mPatient;

        public Chair()
            : base()
        {
            Vector2[] colVerts = new Vector2[4] {new Vector2(0.5f, 0.5f),
                                                             new Vector2(-0.5f, 0.5f),
                                                             new Vector2(-0.5f, -0.5f),
                                                             new Vector2(0.5f, -0.5f)};
            BoundingPolygon = new Polygon(colVerts, true);

            InteractionPoly = new Polygon(new Vector2(Position.X, Position.Z), 15, 2.0f, true);

            Rotation.Y = 225;

            // Create Items list, set default values
            //Items = new List<Item>();
            //Items.Add(Item.None);
            //Items.Add(Item.Baby);
        }

        protected override bool OnInteraction(Interactable other)
        {
            bool success = true;
            
            if (other is Patient)
            {
                if (IsInteractingWith<Patient>())
                {
                    success = false;
                }
                else
                {
                    BeginInteraction(other, -1);
                }
            }

            return success;
        }

        public override void Continue(GameTime gameTime)
        {
            base.Continue(gameTime);
        }

        public override void InteractionComplete(Interaction interaction)
        {
        }

        public override void Update(GameTime gameTime)
        {
            // Update the Interaction Polygon
            InteractionPoly.Update(new Vector2(Position.X, Position.Z), MathHelper.ToRadians(-Rotation.Y), 1.0f);

            Continue(gameTime);

            base.Update(gameTime);
        }
    }
}
