﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TotallyRadEngine10;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace ProjectMaternity
{
    class ControlScreenState : State
    {
        public override void Load(PersistentData persistent)
        {
            mUI.Add("Controls", new ControlsUI());
        }

        public override void Update(Microsoft.Xna.Framework.GameTime gameTime)
        {
            // Update the UI
            foreach (KeyValuePair<string, UI> ui in mUI)
            {
                ui.Value.Update();
            }

            if (InputManager.HasButtonBeenPressed(Keys.Enter) || InputManager.HasButtonBeenPressed(Buttons.A))
            {              

                LoadingState loadState = new LoadingState();
                loadState.StateToLoad = new PlayState();
                StateManager.SetState(loadState); 
            }
        }

        public override void Draw(Renderer renderer, GameTime gameTime)
        {
            // Draw the UI
            foreach (KeyValuePair<string, UI> ui in mUI)
            {
                ui.Value.Draw(renderer.SpriteBatch);
            }
        }

        public override void Unload(PersistentData persistent)
        {
        }

     
    }
}
