﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TotallyRadEngine10;

namespace ProjectMaternity
{
    // The various items a player can carry
    public enum Item
    {
        None,           // No item
        CleanSheets,    // To make bed
        DirtySheets,    // After making bed
        UltrasoundGel,  // Required for Ultrasound
        Baby            // It's a BABY!
    }

    /// <summary>
    /// Defines an Interaction: 
    /// The Interactable it affects. 
    /// The Item required. 
    /// The required Interactable State. 
    /// The Delay following the Interaction.
    /// </summary>
    public struct Interaction
    {
        private Interactable mInteractable;
        private string mState;
        private Item mItem;
        private float mDelay;

        #region Properties

        public Interactable Interactable
        {
            get
            {
                return mInteractable;
            }
            set
            {
                mInteractable = value;
            }
        }

        public string State
        {
            get
            {
                return mState;
            }
            set
            {
                mState = value;
            }
        }

        public Item Item
        {
            get
            {
                return mItem;
            }
            set
            {
                mItem = value;
            }
        }

        public float Delay
        {
            get
            {
                return mDelay;
            }
            set
            {
                mDelay = value;
            }
        }

        #endregion

        public Interaction(Interactable interactable, Item item, string state)
            : this( interactable, item, state, 0.0f)
        {
        }

        public Interaction(Interactable interactable, Item item, string state, float delay)
        {
            this.mInteractable = interactable;
            this.mItem = item;
            this.mState = state;
            this.mDelay = delay;
           // this.mInteractableRelated = interactable;
        }
    }
}
