﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace ProjectMaternity
{
    public class PregnantLady : Patient
    {
        public PregnantLady(Player player)
            : base (player)
        {
            ////////// Set Up States //////////

            string[] PregnantLadyStates = new string[] { "NeedsAssistance", "Complicated", "Following", "InBed", "Leaving" };
            this.mStates.AddRange(PregnantLadyStates);

            ////////// Set Up Interactions //////////

            this.mInteractions = new Dictionary<string, Interaction>();
            this.mInteractions.Add("GetToFollow", new Interaction(this, Item.None, mStates[1], 3.0f));
        }

        public override void Update(GameTime gameTime)
        {
            // The number of seconds since the last update
            float elapsedTime = (float)gameTime.ElapsedGameTime.TotalMilliseconds / 1000;

            switch (mCurrentState)
            {
                case "Arriving":
                    {
                        // After spawn, move to waiting area
                        break;
                    }

                case "Waiting":
                    {
                        // Wait for a certain amount of time before leaving
                        break;
                    }

                case "Following":
                    {
                        if (mCurrentDelay > 0)
                        {
                            mCurrentDelay -= elapsedTime;
                        }
                        else
                        {
                            // Follow the player, use Dom's pathfinding
                            this.Position = this.mPlayer.Position - new Vector3(5, 0, 0);
                            this.Rotation = this.mPlayer.Rotation;
                        }
                        break;
                    }

                case "InBed":
                    {
                        // Wait in bed for player interaction
                        break;
                    }

                case "Leaving":
                    {
                        // Leave the hospital
                        break;
                    }
            }

            base.Update(gameTime);
        }

        public override void PerformInteraction(string interactionName)
        {
            // Select the relevant interaction
            switch (interactionName)
            {
                case "GetToFollow":
                    {
                        mCurrentState = "Following";
                        break;
                    }
            }
        }
    }
}
