﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TotallyRadEngine10;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace ProjectMaternity
{
    class IntroInfoUI : UI
    {
        int DelayTimer = 0;

        public IntroInfoUI()
        {
            //AddImage("TeamLogo", new Image(new Vector2(640, 712), 1.0f, ContentCache.GetTexture("Sprites\\NinjaVikingWithClaws"), AnimationType.FadeIn, Alignment.Centre, Color.TransparentWhite));
            AddText("Disclaimer", new Text("Not all artwork or sounds are final.\nThe performance of this build may not represent the performance of the final game.\nWe can't be held responsible if your computer blows up or travels through time as a result of running this game.\nAlthough a time travelling computer would be pretty awesome...\nMaybe we DO want to be held responsible for that...\nWe'll get back to you on that. Watch this space!\n\nDUDER.", ContentCache.GetFont("Fonts\\UISmall"),
                                           Color.TransparentWhite, new Vector2(Renderer.BackBufferWidth / 2, (Renderer.BackBufferHeight / 2) - 112), 1.0f, AnimationType.FadeIn, Alignment.Centre));
        }

        public override void Update()
        {
            if (GetText("Disclaimer").Animation == AnimationType.None)
            {
                DelayTimer++;

                if (DelayTimer == 200)
                {
                    GetText("Disclaimer").Animation = AnimationType.FadeOut;
                }
                else if (DelayTimer > 200)
                {
                    StateManager.SetState(new MenuState());
                }
            }

            if(InputManager.HasButtonBeenPressed(Buttons.A) ||
                InputManager.HasButtonBeenPressed(Buttons.Start) ||
                InputManager.HasButtonBeenPressed(Keys.Space) ||
                InputManager.HasButtonBeenPressed(Keys.Enter))
            {
                StateManager.SetState(new MenuState());
            }

            base.Update();
        }
    }
}
