﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TotallyRadEngine10;
using Microsoft.Xna.Framework;

namespace ProjectMaternity
{
    class IntroState : State
    {
        public override void Load(PersistentData persistent)
        {
            mUI.Add("IntroInfo", new IntroInfoUI());

            AudioPlayer.PlaySound("MainMenuMusic");
        }

        public override void Update(GameTime gameTime)
        {
            foreach (KeyValuePair<string, UI> ui in mUI)
            {
                ui.Value.Update();
            }
        }

        public override void Draw(Renderer renderer, GameTime gameTime)
        {
            foreach (KeyValuePair<string, UI> ui in mUI)
            {
                ui.Value.Draw(renderer.SpriteBatch);
            }
        }

        public override void Unload(PersistentData persistent)
        {
        }
    }
}
