﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TotallyRadEngine10;

namespace ProjectMaternity
{
    class LoadingState : State
    {
        bool mDrawOnce = false;
        public State StateToLoad;

        public override void Load(PersistentData persistent)
        {
            mUI.Add("LoadingUI", new LoadingUI());
        }

        public override void Update(Microsoft.Xna.Framework.GameTime gameTime)
        {
            // Update the UI
            foreach (KeyValuePair<string, UI> ui in mUI)
            {
                ui.Value.Update();
            }

            // Let the UI be drawn at least once so it's on the screen whilst the next state loads
            if (mDrawOnce)
            {
                StateManager.SetState(StateToLoad);
            }
        }

        public override void Draw(Renderer renderer, Microsoft.Xna.Framework.GameTime gameTime)
        {
            // Draw the UI
            foreach (KeyValuePair<string, UI> ui in mUI)
            {
                ui.Value.Draw(renderer.SpriteBatch);
            }

            mDrawOnce = true;
        }

        public override void Unload(PersistentData persistent)
        {       
        }
    }
}
