﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TotallyRadEngine10;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace ProjectMaternity
{
    class MapUI : UI
    {
        public float MortalityRate;
        public int Objective;
        public Locations CurrentLocation;

        public MapUI()
            : base()
        {

            Image orb = new Image(Vector2.Zero, 1.0f, ContentCache.GetTexture("Sprites\\Orb"), AnimationType.Pulsate, Alignment.Centre);
            AddImage("Orb", orb);

            Image bgImg = new Image(new Vector2(Renderer.BackBufferWidth / 2, Renderer.BackBufferHeight / 2), 1.0f, ContentCache.GetTexture("Sprites\\Map"), AnimationType.None, Alignment.Centre);
            AddImage("BG", bgImg);

            Text location = new Text("Kathmandu", ContentCache.GetFont("Fonts\\UI"), Color.White, new Vector2(900, 834), 0.7f, AnimationType.None, Alignment.Default);
            AddText("Location", location);

            Text objective = new Text("1", ContentCache.GetFont("Fonts\\UI"), Color.White, new Vector2(900, 928), 0.7f, AnimationType.None, Alignment.Default);
            AddText("Objective", objective);

            Text maternityMortalityRate = new Text("1", ContentCache.GetFont("Fonts\\UI"), Color.White, new Vector2(980, 881), 0.7f, AnimationType.None, Alignment.Default);
            AddText("Maternity", maternityMortalityRate);

            Text unavailable = new Text("Not available in this demo!", ContentCache.GetFont("Fonts\\UI"), Color.White, new Vector2(500, 512), 0.7f, AnimationType.None, Alignment.Default);
            AddText("Unavailable", unavailable);
        }

        public override void Update()
        {
            // Display message when highlighting unavailable levels
            GetText("Unavailable").String = "Not available in this demo!";

            switch (CurrentLocation)
            {
                case Locations.Rajasthan:
                    {
                        // Reposition the pulsating orb
                        GetImage("Orb").Position = new Vector2(297, 167);                       

                        // Remove unavailable warning when highlighting Rajasthan
                        GetText("Unavailable").String = "";

                        break;
                    }
                case Locations.Kathmandu:
                    {
                        // Reposition the pulsating orb
                        GetImage("Orb").Position = new Vector2(768, 160);

                        // Remove unavailable warning when highlighting Kathmandu
                        GetText("Unavailable").String = "";

                        break;
                    }
                
            }

            // Set the text to display the correct info depending on the location
            GetText("Location").String = CurrentLocation.ToString();
            GetText("Maternity").String = MortalityRate.ToString();
            GetText("Objective").String = "Treat " + Objective.ToString() + "patients";

            base.Update();
        }

    }
}
