﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TotallyRadEngine10;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework;
using PolygonCollisionLibrary;

namespace ProjectMaternity
{
    public class Player : Nurse
    {        
        private bool mCanMove = true;
        Vector2 mLastAnalogStickPos;

        public bool CanMove 
        {
            get
            {
                return mCanMove;
            }
            set
            {
                mCanMove = value;
            }
        }

        public Player()
            : base()
        { 
            Rotation.Y = 225;         
        }

        public override void Update(GameTime gameTime)
        {
            if (!IsInteractingWith<Bed>() && mCanMove)
            {
                #region Player Movement  
            
                bool inputDetected = false;

                if (InputManager.IsButtonDown(Keys.Up))
                {
                    Rotation.Y = -90;

                    float radAngle = MathHelper.ToRadians(Rotation.Y - 90);

                    // If the rotation is counter-clockwise
                    if (Rotation.Y >= 0)
                    {
                        Position += (new Vector3(0.5f * (float)Math.Cos(radAngle), 0,
                            -0.5f * (float)Math.Sin(radAngle))) * (float)Math.Ceiling(gameTime.ElapsedGameTime.Milliseconds / ((1.0f / 60.0f) * 1000.0f));
                    }
                    // If the rotation is clockwise
                    else
                    {
                        Position += (new Vector3(0.5f * (float)Math.Cos(radAngle), 0,
                            0.5f * (float)Math.Sin(radAngle))) * (float)Math.Ceiling(gameTime.ElapsedGameTime.Milliseconds / ((1.0f / 60.0f) * 1000.0f));
                    }

                    if (IsAnimationPlaying && !CurrentAnimationName.Contains("Run"))
                    {
                        if (CurrentItem == Item.None)
                        {
                            SetAnimation("Run", 0.0f, 3.0f);
                        }
                        else
                        {
                            SetAnimation("RunSheets", 0.0f, 3.0f);
                        }
                    }

                    inputDetected = true;
                }
            

                if (InputManager.IsButtonDown(Keys.Down))
                {
                    Rotation.Y = -270;

                    float radAngle = MathHelper.ToRadians(Rotation.Y - 90);

                    // If the rotation is counter-clockwise
                    if (Rotation.Y >= 0)
                    {
                        Position += (new Vector3(0.5f * (float)Math.Cos(radAngle), 0,
                            -0.5f * (float)Math.Sin(radAngle))) * (float)Math.Ceiling(gameTime.ElapsedGameTime.Milliseconds / ((1.0f / 60.0f) * 1000.0f));
                    }
                    // If the rotation is clockwise
                    else
                    {
                        Position += (new Vector3(0.5f * (float)Math.Cos(radAngle), 0,
                            0.5f * (float)Math.Sin(radAngle))) * (float)Math.Ceiling(gameTime.ElapsedGameTime.Milliseconds / ((1.0f / 60.0f) * 1000.0f));
                    }

                    if (IsAnimationPlaying && !CurrentAnimationName.Contains("Run"))
                    {
                        if (CurrentItem == Item.None)
                        {
                            SetAnimation("Run", 0.0f, 3.0f);
                        }
                        else
                        {
                            SetAnimation("RunSheets", 0.0f, 3.0f);
                        }
                    }

                    inputDetected = true;
                }

                if (InputManager.IsButtonDown(Keys.Left))
                {
                    Rotation.Y = 0;

                    float radAngle = MathHelper.ToRadians(Rotation.Y - 90);

                    // If the rotation is counter-clockwise
                    if (Rotation.Y >= 0)
                    {
                        Position += (new Vector3(0.5f * (float)Math.Cos(radAngle), 0,
                            -0.5f * (float)Math.Sin(radAngle))) * (float)Math.Ceiling(gameTime.ElapsedGameTime.Milliseconds / ((1.0f / 60.0f) * 1000.0f));
                    }
                    // If the rotation is clockwise
                    else
                    {
                        Position += (new Vector3(0.5f * (float)Math.Cos(radAngle), 0,
                            0.5f * (float)Math.Sin(radAngle))) * (float)Math.Ceiling(gameTime.ElapsedGameTime.Milliseconds / ((1.0f / 60.0f) * 1000.0f));
                    }

                    if (IsAnimationPlaying && !CurrentAnimationName.Contains("Run"))
                    {
                        if (CurrentItem == Item.None)
                        {
                            SetAnimation("Run", 0.0f, 3.0f);
                        }
                        else
                        {
                            SetAnimation("RunSheets", 0.0f, 3.0f);
                        }
                    }

                    inputDetected = true;
                }

                if (InputManager.IsButtonDown(Keys.Right))
                {
                    Rotation.Y = 180;

                    float radAngle = MathHelper.ToRadians(Rotation.Y - 90);

                    // If the rotation is counter-clockwise
                    if (Rotation.Y >= 0)
                    {
                        Position += (new Vector3(0.5f * (float)Math.Cos(radAngle), 0,
                            -0.5f * (float)Math.Sin(radAngle))) * (float)Math.Ceiling(gameTime.ElapsedGameTime.Milliseconds / ((1.0f / 60.0f) * 1000.0f));
                    }
                    // If the rotation is clockwise
                    else
                    {
                        Position += (new Vector3(0.5f * (float)Math.Cos(radAngle), 0,
                            0.5f * (float)Math.Sin(radAngle))) * (float)Math.Ceiling(gameTime.ElapsedGameTime.Milliseconds / ((1.0f / 60.0f) * 1000.0f));
                    }

                    if (IsAnimationPlaying && !CurrentAnimationName.Contains("Run"))
                    {
                        if (CurrentItem == Item.None)
                        {
                            SetAnimation("Run", 0.0f, 3.0f);
                        }
                        else
                        {
                            SetAnimation("RunSheets", 0.0f, 3.0f);
                        }
                    }

                    inputDetected = true;
                }

                if (InputManager.GetAnalogStickDirection() != Vector2.Zero)
                {              
                    Vector3 direction = new Vector3(-InputManager.GetAnalogStickDirection().Y, 0.0f, -InputManager.GetAnalogStickDirection().X);                               
                    this.Rotation.Y = MathHelper.ToDegrees((float)Math.Atan2(direction.X, direction.Z));

                    if (IsAnimationPlaying && CurrentAnimationName.Contains("Run"))
                    {
                        CurrentAnimation.Speed = (float)MathHelper.Clamp((3.0f * (direction.Length() *4.5f)), 0.0f, 3.0f) * direction.Length();
                    }

                    Position += (direction / 1.5f) * (float)Math.Ceiling(gameTime.ElapsedGameTime.Milliseconds / ((1.0f / 60.0f) * 1000.0f));

                    if (IsAnimationPlaying && !CurrentAnimationName.Contains("Run"))
                    {
                        if (CurrentItem == Item.None)
                        {
                            SetAnimation("Run", 0.0f, 3.0f);
                        }
                        else
                        {
                            SetAnimation("RunSheets", 0.0f, 3.0f);
                        }
                    }

                    inputDetected = true;
                }

                if (!inputDetected && !IsInteractingWith<Bed>())
                {
                    if (IsAnimationPlaying && !CurrentAnimationName.Contains("Idle"))
                    {
                        if (CurrentItem == Item.None)
                        {
                            SetAnimation("Idle", 0.0f, 1.0f);
                        }
                        else
                        {
                            SetAnimation("IdleSheets", 0.0f, 1.0f);
                        }
                    }
                }

                #endregion
            }          

            base.Update(gameTime);
        }
    }
}
