﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TotallyRadEngine10;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace ProjectMaternity
{
    class StatsUIFail : UI
    {
        public int TreatedPatients;
        public int Complications;
        //public int InfantDeaths;
        public int MaternalDeaths;
        public int Objective;

        public StatsUIFail()
            : base()
        {
            Image bgImg = new Image(new Vector2((Renderer.BackBufferWidth / 2), (Renderer.BackBufferHeight / 2)), 1.0f, ContentCache.GetTexture("Sprites\\IntroBG"), AnimationType.None, Alignment.Centre);
            AddImage("BG", bgImg);

            AddText("LvlOver", new Text("Level Failed - Press enter to restart", ContentCache.GetFont("Fonts\\UI"), Color.Red,
               new Vector2(((Renderer.BackBufferWidth / 2) - 640) + 640, ((Renderer.BackBufferHeight / 2) - 512) + 230), 1.0f, AnimationType.Pulsate, Alignment.Centre));

            AddText("Treated", new Text("Patients treated: " + TreatedPatients, ContentCache.GetFont("Fonts\\UI"), Color.White, new Vector2(((Renderer.BackBufferWidth / 2) - 640) + 640, ((Renderer.BackBufferHeight / 2) - 512) + 330), 1.0f, AnimationType.None, Alignment.Centre));
            AddText("Target", new Text("Target Patients treated: " + Objective, ContentCache.GetFont("Fonts\\UI"), Color.White, new Vector2(((Renderer.BackBufferWidth / 2) - 640) + 640, ((Renderer.BackBufferHeight / 2) - 512) + 390), 1.0f, AnimationType.None, Alignment.Centre));
            AddText("Complications", new Text("Birthing complications: " + Complications, ContentCache.GetFont("Fonts\\UI"), Color.White, new Vector2(((Renderer.BackBufferWidth / 2) - 640) + 640, ((Renderer.BackBufferHeight / 2) - 512) + 450), 1.0f, AnimationType.None, Alignment.Centre));
            //AddText("Infant", new Text(InfantDeaths + " in every 1000 babies died", ContentCache.GetFont("Fonts\\UI"), Color.White, new Vector2(((Renderer.BackBufferWidth / 2) - 640) + 640, ((Renderer.BackBufferHeight / 2) - 512) + 450), 1.0f, AnimationType.None, Alignment.Centre));
            //AddText("Maternal", new Text(MaternalDeaths + " in every 1000 mothers died", ContentCache.GetFont("Fonts\\UI"), Color.White, new Vector2(((Renderer.BackBufferWidth / 2) - 640) + 640, ((Renderer.BackBufferHeight / 2) - 512) + 510), 1.0f, AnimationType.None, Alignment.Centre)); 
        }

        public override void Update()
        {
            GetText("Treated").String = "Patients treated: " + TreatedPatients;
            GetText("Target").String = "Target Patients treated: " + Objective;
            GetText("Complications").String = "Birthing complications: " + Complications;

            base.Update();
        }
    }
}
