﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TotallyRadEngine10;
using Microsoft.Xna.Framework;

namespace ProjectMaternity
{
    class TutArrowUI : UI
    {
        private int LastPatientCount;

        public Vector3 Target = Vector3.Zero;        
        public Vector2 ScreenSize = Vector2.Zero;
        public Matrix ViewMatrix;
        public Matrix ProjectionMatrix;

        public TutArrowUI()
            : base()
        {
            LastPatientCount = 0;
            AddImage("Arrow", new Image(Vector2.Zero, 1.0f, ContentCache.GetTexture("Sprites\\TutArrow"), AnimationType.Pulsate, Alignment.Centre));
        }

        public override void Update()
        {
            Vector3 arrowPos3D = new Vector3(Target.X, Target.Y, Target.Z);
            Vector4 transPos = new Vector4(arrowPos3D, 1.0f);
            transPos = Vector4.Transform(transPos, ViewMatrix);
            transPos = Vector4.Transform(transPos, ProjectionMatrix);
            transPos /= transPos.W;

            transPos.X += 1;
            transPos.Y += 1;
            transPos.X /= 2;
            transPos.Y /= 2;
            transPos.X *= Renderer.BackBufferWidth;
            transPos.Y *= Renderer.BackBufferHeight;
            transPos.Y = Renderer.BackBufferHeight - transPos.Y; // Not entirley sure why this is necesarry 

            if (transPos.X >= 0 && transPos.X <= Renderer.BackBufferWidth &&
                transPos.Y >= 0 && transPos.Y <= Renderer.BackBufferHeight)
            {
                GetImage("Arrow").Rotation = 0.0f;
                GetImage("Arrow").Position = new Vector2(transPos.X, transPos.Y - 120);
            }
            else if (transPos.X < 0 &&
                transPos.Y >= 0 && transPos.Y <= Renderer.BackBufferHeight)
            {
                GetImage("Arrow").Rotation = MathHelper.ToRadians(90.0f);
                GetImage("Arrow").Position = new Vector2(46, transPos.Y - 120);
            }
            else if (transPos.X > Renderer.BackBufferWidth &&
                transPos.Y >= 0 && transPos.Y <= Renderer.BackBufferHeight)
            {
                GetImage("Arrow").Rotation = MathHelper.ToRadians(270.0f);
                GetImage("Arrow").Position = new Vector2(Renderer.BackBufferWidth - 46, transPos.Y - 120);
            }

            else if (transPos.Y < 0 &&
                transPos.X >= 0 && transPos.X <= Renderer.BackBufferWidth)
            {
                GetImage("Arrow").Rotation = MathHelper.ToRadians(180.0f);
                GetImage("Arrow").Position = new Vector2(transPos.X, 46);
            }
            else if (transPos.Y > Renderer.BackBufferWidth &&
                 transPos.X >= 0 && transPos.X <= Renderer.BackBufferWidth)
            {
                GetImage("Arrow").Rotation = MathHelper.ToRadians(0.0f);
                GetImage("Arrow").Position = new Vector2(transPos.X, Renderer.BackBufferHeight - 46);
            }

            base.Update();
        }
    }
}
